﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Diagnostics;
using static CryptoCalc.DBClasses;

namespace CryptoCalc
{
    public partial class MainWindow : Window
    {
        private readonly Random rand = new();
        private List<Transaction> transactions = new();
        
        public MainWindow()
        {
            InitializeComponent();
        }

        private void saveButton_Click(object sender, RoutedEventArgs e)
        {
            Transaction rd = DummyTransaction();
            DBInteraction.SaveData(ref rd);
        }

        private void saveButtonFromInput_Click(object sender, RoutedEventArgs e)
        {
            Transaction rd = new(inputCurrency.Text, Convert.ToSingle(inputAmount.Text), inputType.Text);
            DBInteraction.SaveData(ref rd);
        }

        private void readButton_click(object sender, RoutedEventArgs e)
        {
            transactions = DBInteraction.LoadTransactions();
            foreach (Transaction x in transactions)
            {
                Debug.WriteLine($"{x.DateTimeString} *** {x.Currency} - {x.Amount}");
            }
        }
        private void searchButton_Click(object sender, RoutedEventArgs e)
        {
            transactions = DBInteraction.LoadTransactionsOfCurrency(currencyText.Text);
            transactionsFoundListBox.Items.Clear();
            foreach (Transaction x in transactions)
            {
                transactionsFoundListBox.Items.Add(x.FullInfo);
            }
        }

        private Transaction DummyTransaction()
        {
            Transaction t = new();
            t.SaveDateTime();
            t.Currency = "SOL";
            t.Amount = Convert.ToSingle(30 * rand.NextDouble());
            t.TransactionType = "BUY";
            t.Platform = "Firi";
            t.Note = "Test";
            return t;
        }

        private void inputAmount_LostFocus(object sender, RoutedEventArgs e)
        {
            inputAmount.Text = inputAmount.Text.Replace(".", ",");
        }
    }
}
